open Term
open Subst
open Overlap
open Rewriting
open Format

let rec reachable_aux n rules ss ts =
  if n = 0 then ss else
  let us = 
    Listx.unique 
      [ u | t <- ts; u <- rewrite rules t; not (List.mem u ss) ] in
  reachable_aux (n - 1) rules (us @ ss) us

let reachable n rules ts = reachable_aux n rules ts ts

let intersect xs ys = List.exists (fun x -> List.mem x ys) xs

let joinable n rules (s, t) = 
  intersect (reachable n rules [s]) (reachable n rules [t]) 

let wcr_n n rules =
  List.for_all (joinable n rules) (cp rules)

let wcr_kb tool rules =
  Sn.sn tool rules [] &&
  List.for_all 
    (fun (s, t) -> Rewriting.nf rules s = Rewriting.nf rules t)
    (cp rules)
